Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions
TF_DecryptorImpl< SCHEME_OPTIONS > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for TF_DecryptorImpl< SCHEME_OPTIONS >:

List of all members.

## Public Types

typedef SCHEME_OPTIONS::PrivateKey | KeyClass
typedef SCHEME_OPTIONS | SchemeOptions

## Public Member Functions

const KeyClass & | GetKey () const
KeyClass & | AccessKey ()
PublicKey & | AccessPublicKey ()
const PublicKey & | GetPublicKey () const
PrivateKey & | AccessPrivateKey ()
const PrivateKey & | GetPrivateKey () const
const KeyClass & | GetTrapdoorFunction () const
PK_MessageAccumulator * | NewSignatureAccumulator (RandomNumberGenerator &rng) const
PK_MessageAccumulator * | NewVerificationAccumulator () const
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, size_t ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a byte string, and return the length of plaintext
bool | ParameterSupported (const char *name) const
| this object supports the use of the parameter with the given name
size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
size_t | MaxPlaintextLength (size_t ciphertextLength) const
| maximum length of plaintext for a given ciphertext length
size_t | CiphertextLength (size_t plaintextLength) const
| calculate length of ciphertext given length of plaintext
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Types

typedef TrapdoorFunctionInverse | TrapdoorFunctionInterface
typedef PK_EncryptionMessageEncodingMethod | MessageEncodingInterface

## Protected Member Functions

const TF_DecryptorBase::MessageEncodingInterface & | GetMessageEncodingInterface () const
const TrapdoorFunctionBounds & | GetTrapdoorFunctionBounds () const
const TF_DecryptorBase::TrapdoorFunctionInterface & | GetTrapdoorFunctionInterface () const
HashIdentifier | GetHashIdentifier () const
size_t | GetDigestSize () const
size_t | PaddedBlockByteLength () const
size_t | PaddedBlockBitLength () const

## Detailed Description

### template<class SCHEME_OPTIONS>
class TF_DecryptorImpl< SCHEME_OPTIONS >

_

Definition at line 451 of file pubkey.h.

## Member Function Documentation

DecodingResult TF_DecryptorBase::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const`[virtual, inherited]`

decrypt a byte string, and return the length of plaintext

Precondition:
  size of plaintext == MaxPlaintextLength(ciphertextLength) bytes.

Returns:
  the actual length of the plaintext, indication that decryption failed.

Implements PK_Decryptor.

bool TF_CryptoSystemBase< PK_Decryptor , TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >::ParameterSupported | ( | const char * | name | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 156 of file pubkey.h.

size_t TF_CryptoSystemBase< PK_Decryptor , TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >::FixedCiphertextLength | ( |  | ) | const`[inline, virtual, inherited]`

Implements PK_FixedLengthCryptoSystemImpl< PK_Decryptor >.

Definition at line 158 of file pubkey.h.

size_t PK_FixedLengthCryptoSystemImpl< PK_Decryptor >::MaxPlaintextLength | ( | size_t | ciphertextLength | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 142 of file pubkey.h.

size_t PK_FixedLengthCryptoSystemImpl< PK_Decryptor >::CiphertextLength | ( | size_t | plaintextLength | ) | const`[inline, virtual, inherited]`

Implements PK_CryptoSystem.

Definition at line 144 of file pubkey.h.

virtual BufferedTransformation* PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const`[virtual, inherited]`

create a new decryption filter

Note:
  caller is responsible for deleting the returned pointer

The documentation for this class was generated from the following file:

- pubkey.h